Gecode::BoolVarBranch Class Reference
Functionality by programming task » Programming models » Using integer variables and constraints » Branching

Which Boolean variable to select for branching. More...

`#include <int.hh>`

## Public Types

enum | Select { SEL_NONE = 0 , SEL_RND , SEL_MERIT_MIN , SEL_MERIT_MAX , SEL_DEGREE_MIN , SEL_DEGREE_MAX , SEL_AFC_MIN , SEL_AFC_MAX , SEL_ACTION_MIN , SEL_ACTION_MAX , SEL_CHB_MIN , SEL_CHB_MAX }
| Which variable selection. More...
Public Types inherited from Gecode::VarBranch< BoolVar >
typedef BranchTraits< BoolVar >::Merit | MeritFunction
| Corresponding merit function.

## Public Member Functions

| BoolVarBranch (void)
| Initialize with strategy SEL_NONE.
| BoolVarBranch (Rnd r)
| Initialize with random number generator r.
| BoolVarBranch (Select s, BranchTbl t)
| Initialize with selection strategy s and tie-break limit function t.
| BoolVarBranch (Select s, double d, BranchTbl t)
| Initialize with selection strategy s, decay factor d, and tie-break limit function t.
| BoolVarBranch (Select s, BoolAFC a, BranchTbl t)
| Initialize with selection strategy s, AFC a, and tie-break limit function t.
| BoolVarBranch (Select s, BoolAction a, BranchTbl t)
| Initialize with selection strategy s, action a, and tie-break limit function t.
| BoolVarBranch (Select s, BoolCHB c, BranchTbl t)
| Initialize with selection strategy s, CHB c, and tie-break limit function t.
| BoolVarBranch (Select s, BoolBranchMerit mf, BranchTbl t)
| Initialize with selection strategy s, branch merit function mf, and tie-break limit function t.
Select | select (void) const
| Return selection strategy.
void | expand (Home home, const BoolVarArgs &x)
| Expand decay factor into AFC or action.
Public Member Functions inherited from Gecode::VarBranch< BoolVar >
| VarBranch (void)
| Initialize.
BranchTbl | tbl (void) const
| Return tie-break limit function.
Rnd | rnd (void) const
| Return random number generator.
double | decay (void) const
| Return decay factor.
AFC | afc (void) const
| Return AFC.
Action | action (void) const
| Return action.
CHB | chb (void) const
| Return CHB.
MeritFunction | merit (void) const
| Return merit function.

## Protected Attributes

Select | s
| Which variable to select.
Protected Attributes inherited from Gecode::VarBranch< BoolVar >
BranchTbl | _tbl
| Tie-breaking limit function.
Rnd | _rnd
| Random number generator.
double | _decay
| Decay information for AFC and action.
AFC | _afc
| AFC information.
Action | _act
| Action information.
CHB | _chb
| CHB information.
MeritFunction | _mf
| Merit function.

## Detailed Description

Which Boolean variable to select for branching.

Definition at line 4656 of file int.hh.

## Member Enumeration Documentation

## Select

enum Gecode::BoolVarBranch::Select

Which variable selection.

Enumerator
SEL_NONE | First unassigned.
SEL_RND | Random (uniform, for tie breaking).
SEL_MERIT_MIN | With least merit.
SEL_MERIT_MAX | With highest merit.
SEL_DEGREE_MIN | With smallest degree.
SEL_DEGREE_MAX | With largest degree.
SEL_AFC_MIN | With smallest accumulated failure count.
SEL_AFC_MAX | With largest accumulated failure count.
SEL_ACTION_MIN | With lowest action.
SEL_ACTION_MAX | With highest action.
SEL_CHB_MIN | With lowest CHB.
SEL_CHB_MAX | With highest CHB.

Definition at line 4659 of file int.hh.

## Constructor & Destructor Documentation

## BoolVarBranch() [1/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | void |  | ) |

inline

Initialize with strategy SEL_NONE.

Definition at line 308 of file var.hpp.

## BoolVarBranch() [2/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Rnd | r | ) |

inline

Initialize with random number generator r.

Definition at line 316 of file var.hpp.

## BoolVarBranch() [3/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Select | s,
|  | BranchTbl | t )

inline

Initialize with selection strategy s and tie-break limit function t.

Definition at line 312 of file var.hpp.

## BoolVarBranch() [4/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Select | s,
|  | double | d,
|  | BranchTbl | t )

inline

Initialize with selection strategy s, decay factor d, and tie-break limit function t.

Definition at line 320 of file var.hpp.

## BoolVarBranch() [5/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Select | s,
|  | BoolAFC | a,
|  | BranchTbl | t )

inline

Initialize with selection strategy s, AFC a, and tie-break limit function t.

Definition at line 324 of file var.hpp.

## BoolVarBranch() [6/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Select | s,
|  | BoolAction | a,
|  | BranchTbl | t )

inline

Initialize with selection strategy s, action a, and tie-break limit function t.

Definition at line 328 of file var.hpp.

## BoolVarBranch() [7/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Select | s,
|  | BoolCHB | c,
|  | BranchTbl | t )

inline

Initialize with selection strategy s, CHB c, and tie-break limit function t.

Definition at line 332 of file var.hpp.

## BoolVarBranch() [8/8]

Gecode::BoolVarBranch::BoolVarBranch | ( | Select | s,
|  | BoolBranchMerit | mf,
|  | BranchTbl | t )

inline

Initialize with selection strategy s, branch merit function mf, and tie-break limit function t.

Definition at line 336 of file var.hpp.

## Member Function Documentation

## select()

BoolVarBranch::Select Gecode::BoolVarBranch::select | ( | void |  | ) | const

inline

Return selection strategy.

Definition at line 340 of file var.hpp.

## expand()

void Gecode::BoolVarBranch::expand | ( | Home | home,
|  | const BoolVarArgs & | x )

inline

Expand decay factor into AFC or action.

Definition at line 345 of file var.hpp.

## Member Data Documentation

## s

Select Gecode::BoolVarBranch::s

protected

Which variable to select.

Definition at line 4675 of file int.hh.

The documentation for this class was generated from the following files:

- gecode/int.hh
- gecode/int/branch/var.hpp